// MIDITest - determines if the timing issue can be solved simply with JFugue
// result: it cannot be solved by simply stripping timing info... seems that JFugue reads things in at twice the tempo...

// Jacob Peck - Team La-a
// CSC 380 - Early
// 24 October 2011


// compilation: javac -cp path/to/jfugue.jar:. MIDIManip.java
// usage: java -cp path/to/jfugue.jar:. MIDIManip some-input-midi-file.midi

import org.jfugue.*;
import java.io.*;
import java.util.*;

public class MIDITest {
  public static void main(String[] args) throws Exception {
    String filename = args[0];
    Player player = new Player();
    Pattern pattern = player.loadMidi(new File(filename));
    String musicstring = pattern.getMusicString();
    System.out.println("Original: " + musicstring);
    Scanner sc = new Scanner(musicstring);
    StringBuilder newmusicstring = new StringBuilder();
    while(sc.hasNext()) {
      String token = sc.next();
      if (token.startsWith("@")) {
        System.out.println("Skipping timing command: " + token);
      } else {
        newmusicstring.append(" " + token);
      }
    }
    String newmusicstringval = newmusicstring.toString().trim();
    System.out.println("New: " + newmusicstringval);
    pattern.setMusicString(newmusicstringval);
    player.saveMidi(pattern, new File(filename + ".NEW.midi"));
  
    System.exit(0);
  }
}
